<template>
  <section class="cart-list-desktop d-none d-lg-block pb-3">
    <div class="container">
      <div class="row">
        <div class="col">
          <div
            class="list-content d-flex flex-column flex-md-row justify-content-md-between align-items-md-center"
          >
            <h2 class="title my-0">
              <span class="text-primary">
                <i class="fas fa-chevron-right" aria-hidden="true"></i>
              </span>
              Mi bolsa de compras
            </h2>
          </div>
        </div>
      </div>
    </div>

    <section class="pl-3">
      <table class="table table-borderless mt-3" v-if="cart.length">
        <thead>
          <tr>
            <th scope="col"></th>
            <th scope="col">Producto</th>
            <th scope="col" class="text-center">Cantidad</th>
            <th scope="col">Precio unidad</th>
            <th scope="col"></th>
          </tr>
        </thead>
        <tbody>
          <tr class="mt-3" v-for="(item, index) in cart" :key="item.id">
            <th scope="row">
              <img
                :src="item.foto_real.url"
                alt=""
                class="table-img"
                v-if="item.foto_real"
              />
            </th>
            <td class="td-name pt-4">
              <span class="name pt-1">{{ item.name }}</span>
            </td>
            <td class="td-controls pt-4">
              <Controls :product="item" :index="index" />
            </td>
            <td class="td-price pt-4">
              <section class="price d-flex">
                <div class="with-offer" v-if="item.precio_descuento">
                  <h3 class="real mt-0">{{ price(item.precio_real) }}</h3>
                  <h3 class="offer my-0">{{ price(item.precio_descuento) }}</h3>
                </div>
                <div class="d-flex align-items-center" v-else>
                  <h3 class="offer my-0">{{ price(item.precio_real) }}</h3>
                </div>
              </section>
            </td>
            <td class="pt-4">
              <div class="d-flex align-items-center h-100 mt-1">
                <button
                  class="btn-delete bg-transparent border-0"
                  @click="removeProduct(index)"
                >
                  <i class="fas fa-trash-alt" aria-hidden="true"></i>
                </button>
              </div>
            </td>
          </tr>
        </tbody>
      </table>

      <div class="text-center mt-5" v-else>
        <div class="pt-4">
          <span class="h1 text-muted">
            <i class="fas fa-shopping-cart"></i>
          </span>
          <p class="mb-1">Su carrito está vacío.</p>
          <nuxt-link to="/" class="text-success">
            <i class="fas fa-chevron-left"></i>
            Regresar
          </nuxt-link>
        </div>
      </div>
    </section>
  </section>
</template>

<script>
import { mapGetters } from "vuex";

import { priceFormat } from "@/utils/price-format.js";

import Card from "./Card";
import Controls from "./Controls.vue";

export default {
  name: "CartListDesktop",
  components: {
    Card,
    Controls,
  },
  data() {
    return {};
  },
  methods: {
    price(val) {
      return priceFormat(val);
    },
    removeProduct(index) {
      this.$store.commit("cart/REMOVE_PRODUCT", index);
    },
  },
  computed: {
    ...mapGetters({
      cart: "cart/getCart",
    }),
  },
};
</script>

<style lang="scss" scoped>
@import "~/assets/scss/variables";

.cart-list-desktop {
  .title {
    font-size: 1.2em;
    font-weight: 700;
  }

  .table-img {
    width: 70px;
  }

  thead,
  tbody tr {
    box-shadow: 0 3px 6px rgb(0 0 0 / 8%);
  }

  th {
    font-size: 0.9em;
  }

  .td-name {
    width: 100px;

    @media (min-width: 1200px) {
      width: auto;
    }
  }

  .td-controls,
  .td-price {
    @media (min-width: 1200px) {
      width: auto;
    }
  }

  .name {
    font-size: 9px;
    line-height: 12px;
    display: inline-block;

    @media (min-width: 1200px) {
      font-size: 13px;
      line-height: 15px;
    }
  }

  .btn-delete {
    color: rgba($secondary, 0.5);
    transition: color 0.1s;

    &:hover {
      color: $secondary;
    }
  }
}

.price-container {
  grid-column: 1 / 2;
  grid-row: 2 / 3;
}

.price {
  height: 40px;

  .with-offer {
    .real {
      font-size: 11px;
      color: rgba($dark, 0.8);
      text-decoration: line-through;
      margin-bottom: 3px;
    }
  }

  h3 {
    font-size: 1.1em;
    font-weight: 700;
    margin: 0;
  }

  .offer {
    font-size: 0.9em;
    color: $primary;
  }
}
</style>
